<?php
/*

>>>>>> CrazyStat <<<<<<
Ein komfortables, umfangreiches und kostenloses Statistik-Script mit oder ohne Counter.

Copyright (C) 2004-2007  Crazy Chrissi

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

E-Mail: christosoft4u AT yahoo DOT de
Web: http://www.christosoft.de
Version: 1.61

*** log_funcs.php ***
Funktion:    Bietet Funktionen zum Umgang mit Logfiles
Aufrufbar:   nein
Eingebunden: von stat.php, show_log.php, show_stat.php (require_once)
*/

require_once('config.php');

function convert_log_data($datenIn, $verIn=1.5, $verOut=1.6)
 {
 if($verIn==1.6 && $verOut==1.5)  // neue -> alte Log umwandeln
  {
  $datenOut[0]=(isset($datenIn[0])?$datenIn[0]:'');;
  $datenOut[1]='|';
  $datenOut[2]=(isset($datenIn[1])?$datenIn[1]:'');;
  $datenOut[3]='|';
  @$datenOut[4]=date('H',$datenIn[1]);
  @$datenOut[5]=date('i',$datenIn[1]);
  @$datenOut[6]=date('s',$datenIn[1]);
  $datenOut[7]='|';
  @$datenOut[8]=date('w',$datenIn[1]);
  $datenOut[9]='|';
  @$datenOut[10]=date('d',$datenIn[1]);
  @$datenOut[11]=date('m',$datenIn[1]);
  @$datenOut[12]=date('Y',$datenIn[1]);
  $datenOut[13]='|';
  $datenOut[14]=(isset($datenIn[2])?$datenIn[2]:'');;
  $datenOut[15]='|';
  $datenOut[16]=(isset($datenIn[3])?$datenIn[3]:'');;
  $datenOut[17]='|';
  $datenOut[18]=(isset($datenIn[4])?$datenIn[4]:'');;
  $datenOut[19]='|';
  $datenOut[20]=(isset($datenIn[5])?$datenIn[5]:'');;
  $datenOut[21]='|';
  $datenOut[22]=(isset($datenIn[6])?$datenIn[6]:'');
  $datenOut[23]='|';
  $datenOut[24]=(isset($datenIn[7])?$datenIn[7]:'');
  }
 elseif($verIn==1.5 && $verOut==1.6) // ohne Parameter: alte -> neu Log umwandeln
  {
  $datenOut[0]=(isset($datenIn[0])?$datenIn[0]:'');
  $datenOut[1]=(isset($datenIn[2])?$datenIn[2]:'');
  $datenOut[2]=(isset($datenIn[14])?$datenIn[14]:'');
  $datenOut[3]=(isset($datenIn[16])?$datenIn[16]:'');
  $datenOut[4]=(isset($datenIn[18])?$datenIn[18]:'');
  $datenOut[5]=(isset($datenIn[20])?$datenIn[20]:'');
  $datenOut[6]=(isset($datenIn[22])?$datenIn[22]:'');
  $datenOut[7]=(isset($datenIn[24])?$datenIn[24]:'');
  $datenOut['m']=(isset($datenIn[11])?$datenIn[11]:'');
  $datenOut['Y']=(isset($datenIn[12])?$datenIn[12]:'');
  $datenOut['d']=(isset($datenIn[10])?$datenIn[10]:'');
  $datenOut['w']=(isset($datenIn[8])?$datenIn[8]:'');
  $datenOut['H']=(isset($datenIn[4])?$datenIn[4]:'');
  }
 return $datenOut;
 }
 
function get_letzte_daten($logdatei)
 {
 global $letzte_daten;
 // Gehe 11 Zeilen zurck und suche nach unkomprimierten Daten (alle 10 Zeilen ist ein kompletter Datensatz verpflichtend)
 $startpos=ftell($logdatei);
 for($i=0;$i<=11;$i++)
  {
  while(fgetc($logdatei)!= "\n")
   {
   $a=ftell($logdatei);
   if($a<2) break;
   fseek($logdatei,$a-2) ;
   }
  $a=ftell($logdatei);
  $zeile=fgets($logdatei);
  if(!empty($zeile))
   {
   $dat=explode("#",$zeile);
   foreach($dat as $id=>$data)
    {
    $data=trim($data);
    if($data!='^' && !isset($letzte_daten[$id])) $letzte_daten[$id]=$data;
    }
   }
  fseek($logdatei,$a-2);
  }
 fseek($logdatei,$startpos); // gehe zurueck wohin der zeiger stand
 }

function get_last_log($path='')
 {
 global $config_logdatei_maxsize,$neue_datei;
 $name=split_log_name();
 $ext=$name['ext'];
 $name=$name['name'];
 $i=0;
 $neue_datei=false;
 while(is_file($path.$name.$i.$ext))
  {
  $i++;
  }
 $i--;
 @$log_size=filesize($path.$name.$i.$ext)/1000;
 if(!is_dir(dirname($path.$name))) return false;
 if($i==-1 || ($config_logdatei_maxsize!==false && $log_size>=$config_logdatei_maxsize))     // neue Datei anlegen
  {
  $i++;
  $neue_log=fopen($path.$name.$i.$ext,"w");
  fclose($neue_log);
  $neue_datei=true;
  }
 return $path.$name.$i.$ext;
 }
 
function get_first_log()
 {
 $name=split_log_name();
 $ext=$name['ext'];
 $name=$name['name'];

 $name=$name.'0'.$ext;
 if(!is_file($name))
  {
  @$neue_log=fopen($name,"w");
  @fclose($neue_log);
  }
 return $name;
 }
 
function get_next_line()
 {
 global $handle, $logdatei_name;
 if(feof($handle))                        // naechste Datei oeffnen
  {
  $name=substr($logdatei_name,0,strrpos($logdatei_name,'.'));
  $ext=substr($logdatei_name,strrpos($logdatei_name,'.'));
  preg_match('/.*?([0-9]+)/',$name,$matches);
  $i=$matches[1];
  $name=substr($name,0,strpos($name,$i));
  $i++;
  if(is_file($name.$i.$ext))
   {
   $logdatei_name=$name.$i.$ext;
   $handle=fopen($name.$i.$ext,'r');
   $zeile=trim(fgets($handle));
   }
  else return false;
  }
 else
  {
  $zeile=trim(fgets($handle));
  if(empty($zeile)) $zeile=get_next_line();
  }
 return $zeile;
 }

function split_log_name()
 {
 global $config_logdatei_ordner,$config_logdatei_name;
 $name_t=$config_logdatei_ordner.'/'.$config_logdatei_name;
 $name['name']=substr($name_t,0,strrpos($name_t,'.'));
 $name['ext']=substr($name_t,strrpos($name_t,'.'));
 return $name;
 }

function linkprep ($p_url) {
// Diese Funktion kodiert eine URL so, dass sie in <a href=""> eingesetzt werden kann, der Link funktioniert aber das HTML valide bleibt.

// vielen dank an dphantom at ticino dot com fr diese Funktion (verffentlicht unter http://www.php.net/manual/de/function.rawurlencode.php)
// die Funktion wurde leicht angepasst, um notice-fehlermeldungen zu unterdruecken
     $ta = parse_url($p_url);
     if (!empty($ta['scheme'])) { @$ta['scheme'].='://'; }
     if (!empty($ta['pass']) and !empty($ta['user'])) {
             @$ta['user'].=':';
             @$ta['pass']=rawurlencode($ta['pass']).'@';
     } elseif (!empty($ta['user'])) {
         @$ta['user'].='@';
     }
     if (!empty($ta['port']) and !empty($ta['host'])) {
         @$ta['host']=''.$ta['host'].':';
     } elseif    (!empty($ta['host'])) {
         @$ta['host']=$ta['host'];
     }
     if (!empty($ta['path'])) {
         $tu='';
         $tok=strtok($ta['path'], "\\/");
         while (strlen($tok)) {
             @$tu.=rawurlencode($tok).'/';
             $tok=strtok("\\/");
         }
         @$ta['path']='/'.trim($tu, '/');
     }
     if (!empty($ta['query'])) { $ta['query']='?'.$ta['query']; }
     if (!empty($ta['fragment'])) { $ta['fragment']='#'.$ta['fragment']; }
     return str_replace('&','&amp,',@implode('', array($ta['scheme'], $ta['user'], $ta['pass'], $ta['host'], $ta['port'], $ta['path'], $ta['query'], $ta['fragment'])));
 }

/*
################ getDateFast ################
This is an equivalent to the php-function getdate() which is faster in most cases.
Note that the result is different from getdate.
To get a more featured version (dectection for minute and second) and more information, visit my website.

Author: Crazy Chrissi
Website: http://christosoft.de
Mail: christosoft4u AT yahoo DOT de

*/


function getDateFast($stamp)
 {
 if(!is_numeric($stamp)) $stamp=0;

 // Note: These arrays are beeing filled automatically if values are missing

 // Seconds of the months 11/2005 to 1/2010 (1st 00:00:00)
 static $secs=array(1130799600,1133391600,1136070000,1138748400,1141167600,1143842400,1146434400,1149112800,1151704800,1154383200,1157061600,1159653600,1162335600,1164927600,1167606000,1170284400,1172703600,1175378400,1177970400,1180648800,1183240800,1185919200,1188597600,1191189600,1193871600,1196463600,1199142000,1201820400,1204326000,1207000800,1209592800,1212271200,1214863200,1217541600,1220220000,1222812000,1225494000,1228086000,1230764400,1233442800,1235862000,1238536800,1241128800,1243807200,1246399200,1249077600,1251756000,1254348000,1257030000,1259622000,1262300400);
 // weekdays of the timestamps above
 static $wdays=array(2        ,4         ,0         ,3         ,3         ,6         ,1         ,4         ,6         ,2         ,5         ,0         ,3         ,5         ,1         ,4         ,4         ,0         ,2         ,5         ,0         ,3         ,6         ,1         ,4         ,6         ,2         ,5         ,6         ,2         ,4         ,0         ,2         ,5         ,1         ,3         ,6         ,1         ,4         ,0         ,0         ,3         ,5         ,1         ,3         ,6         ,2         ,4         ,0         ,2         ,5         );

 // Daylight Saving Time start and end in 2006-2009
 static $dst_start=array(2006=>1143334800,2007=>1174784400,2008=>1206838800,2009=>1238288400);
 static $dst_end=array(2006=>1162083600,2007=>1193533200,2008=>1224982800,2009=>1256432400);

 if($stamp<820450800) // before 1.1.96 (slow and bad) => use getdate
  {
  $result=getdate($stamp);
  return array($result['year'],$result['mon'],$result['mday'],$result['hours'],$result['wday']);
  }
 elseif($stamp>=1262300400) // if timestamp>=(timestamp of 1.1.2010), start 2010
  {
  $month=1;
  $year=2010;
  $y=50;
  }
 elseif($stamp>=1167606000) // if timestamp>=(timestamp of 1.1.2007), start 2007
  {
  $month=1;
  $year=2007;
  $y=14;
  }
 elseif($stamp>=1130799600)  // normally start 11/2005
  {
  $month=11;
  $year=2005;
  $y=0;
  }
 elseif($stamp>=946681200) // between 1/2000 and 11/2005 => start 1/2000
  {
  $month=1;
  $year=2000;
  $y=-70;
  $secs[$y]=946681200;
  }
 else // between 1/1996 and 1/2000 => start 1/1996
  {
  $month=1;
  $year=1996;
  $y=-118;
  $secs[$y]=820450800;
  }

 // get month and year
 for(;$stamp>=$secs[$y];$y++)
  {
  $month++;
  if($month==13)
   {
   $month=1;
   $year++;
   }
  if(!isset($secs[$y+1])) $secs[$y+1]=mktime(0,0,0,$y+12,1,2005);
  }
 $month--;
 if($month==0)
  {
  $month=12;
  $year--;
  }
 $y--;
 // Daylight Saving Time
 if($month==3 && !isset($dst_start[$year])) $dst_start[$year]=mktime(2,0,0,3,31-date('w',mktime(2,0,0,3,31,$year)),$year);
 elseif($month==10 && !isset($dst_end[$year]))
  {
  $dst_end[$year]=mktime(2,0,0,10,31-date('w',mktime(2,0,0,10,31,$year)),$year);
  }
 if($month==3 && $stamp>=$dst_start[$year]) $monthsecs=$secs[$y]-3600;
 elseif($month==10 && $stamp>=$dst_end[$year]) $monthsecs=$secs[$y]+3600;
 else $monthsecs=$secs[$y]; // seconds of the month

 $totalsecs=$stamp-$monthsecs; // seconds from beginning of the month until stamp
 $daysecs=$totalsecs%86400;    // seconds from the beginning of the day until stamp
 // Calculate Day
 $day=ceil($totalsecs/86400);
 if($day<1)$day=1;

 // calculate hour
 $hour=floor($daysecs/3600);
 // Calculate weekday
 if(!isset($wdays[$y])) $wdays[$y]=date('w',$secs[$y]);
 $weekday=($day+$wdays[$y]-1)%7;
 // Return Values
 return array($year,$month,$day,$hour,$weekday);
 }

?>